import java.awt.*;
import java.applet.Applet;
import java.net.*;

public class ChessCanvas extends Canvas
{
// Variabelen -----------------------------------------------------------
// representatie variabelen

// Twee-dimensionaal array dat bord representeert.
  int bord [][];
// Op positie (i,j) staat wat op veld (i,j) staat (a1 = 0,0; b3= 2,3; h8 = 7,7)
// 1000 = niet bestaand veld
// 0 = leeg veld
// 1 = witte koning;
// 2 = zwarte koning;
// 3 = witte dame;
// 4 = zwarte dame;
// 5 = witte toren;
// 6 = zwarte toren;
// 7 = wit paard;
// 8 = zwart paard;
// 9 = witte loper;
// 10 = zwarte loper;
// 11 = witte pion;
// 12 = zwarte pion;
// 13 = witte chancellor;
// 14 = zwarte chancellor;
// 15 = witte marshall;
// 16 = zwarte marshall;

// Stukken voor Bishops conversion rule:
// 31 = unconverted bishop. Can move as bishop or wazir. L in setup
// 32 = idem. Black                                      l in setup
// 33 = to be converted bishop. Must make a wazir move, then
//      moves as bishop. White
// 34 = idem. Black


  char kleurveld [][];
// op positie (i,j) staat de kleur van veld (i,j)
// W = wit
// b = lichtblauw
// B = donkerblauw
// R = rood
// X = zwart

Color lightsquarecolor;
Color darksquarecolor;

  int veldgrootte; // aantal pixels voor velden in lengte en breedte
  int aantalrijen;
  int aantalkolommen;

// Images laden
  MediaTracker tracker;
  Image WhitePawn, BlackPawn;
  Image WhiteKing, BlackKing;
  Image WhiteQueen, BlackQueen;
  Image WhiteRook, BlackRook;
  Image WhiteBishop, BlackBishop;
  Image WhiteKnight, BlackKnight;
  Image WhiteMarshal, BlackMarshal;
  Image WhiteChancellor, BlackChancellor;

// Parent applet (e.g., for documentbase)

  Applet parent;

  ChessMoveChecker controle;

// Variabelen voor interface status:

   // wat is het laatste veld waarop geklikt wordt, en waarvan een stuk moet
   // worden verplaatst?
   // -1 als niet van toepassing
   int rijgeklikt;
   int kolomgeklikt;

// -----------------------------------------------------------------------

// Constructor methode
// Parameters: sqsize: formaat van een veld zoals het getekend moet worden
//             aantalrijen: aantal rijen op het bord (standaard: 8)
//             aantalkolommen: aantal kolommen op het bord (standaard: 8)
//             hetbord: pointer naar abstracte weergave van het bord.

  ChessCanvas (int sqsize, int rijen, int kolommen, Applet theapplet)
  {
    veldgrootte = sqsize;
    aantalrijen = rijen;
    aantalkolommen = kolommen;
    bord      = new int[aantalkolommen][aantalrijen];
    kleurveld = new char[aantalkolommen][aantalrijen];
    for (int i=0; i< aantalkolommen; i++)
    for (int j=0; j< aantalrijen; j++)
    {
      bord[i][j] = 0;                  // initialize with all squares empty
      if ((i+j) % 2 == 0)
        { kleurveld[i][j]= 'B';
	}
      else
	{ kleurveld[i][j]= 'b';
	}
    }

    parent = theapplet;
    controle = new ChessMoveChecker(this);

    rijgeklikt = -1;
    kolomgeklikt = -1;

    darksquarecolor = new Color(0,200,200);
    lightsquarecolor = new Color(240,240,0);
  }

public void reset()
{
// resetting bord must be done elsewhere
    rijgeklikt = -1;
    kolomgeklikt = -1;
    controle.initialize();
}

// Paint methode.
  public void paint (Graphics g)
  {
   // color squares
    for (int i = 0; i<aantalkolommen ; i++)
    {for (int j = 0; j<aantalrijen ; j++)
     {
       drawsquare (g, i, j);
     }
    }
   // draw pieces

   for (int i = 0; i<aantalkolommen; i++)
   for (int j = 0; j<aantalrijen; j++)

   drawpiece (g,i,j);
  }

// Tekent vakje (i,j): i kolom, j rij
public void drawsquare( Graphics g, int i, int j)
{
 if (i == kolomgeklikt && j == rijgeklikt)
 {
    g.setColor(Color.red);
    g.fillRect(i*veldgrootte, (aantalrijen-j-1)* veldgrootte, veldgrootte, veldgrootte);
 }
 else if ((kleurveld[i][j]=='W') || bord[i][j] == 1000)
  {
    g.setColor(Color.white);
    g.fillRect( i * veldgrootte, (aantalrijen-j-1)* veldgrootte, veldgrootte, veldgrootte);
  }
 else if (kleurveld[i][j]=='w')
  {
    g.setColor(Color.white);
    g.fillRect( i * veldgrootte, (aantalrijen-j-1)* veldgrootte, veldgrootte, veldgrootte);
  }
 else if (kleurveld[i][j]=='b')
  {
    g.setColor(lightsquarecolor);
    g.fillRect( i * veldgrootte, (aantalrijen-j-1)* veldgrootte, veldgrootte, veldgrootte);
  }
  else if (kleurveld[i][j]=='B')
  {
    g.setColor(darksquarecolor);
    g.fillRect( i * veldgrootte, (aantalrijen-j-1)* veldgrootte, veldgrootte, veldgrootte);
  }
  else if (kleurveld[i][j]=='R')
  {
    g.setColor(Color.red);
    g.fillRect( i * veldgrootte, (aantalrijen-j-1)* veldgrootte, veldgrootte, veldgrootte);
  }
  else if (kleurveld[i][j]=='X')
  {
    g.setColor(Color.black);
    g.fillRect( i * veldgrootte, (aantalrijen-j-1)* veldgrootte, veldgrootte, veldgrootte);
  }
}


// mouseDown methode
// bepaalt waar geklikt is en roept `geklikt' aan.
public boolean mouseDown (Event ev, int x, int y)
  {
    if (ev.modifiers == 0)
    {
      int kolom = x/ veldgrootte;
      int rij = aantalrijen - y/veldgrootte - 1;
      geklikt (kolom, rij);
      repaint();
      return true;
    }
// the right-mouse click event is captured by the applet
    else return false;
  }

// i is de kolom waarin geklikt is
// j is de rij waarin geklikt is
void geklikt (int i, int j)
{
// if we click on white-colored, i.e., non-existing square, nothing happens
if (bord[i][j] != 1000)
{
   if (rijgeklikt == -1) // eerste deel van zet
   {
// Select the square if there is a piece on it of the player that should move
     if (bord[i][j] > 0)
     { 
       if (controle.RightPlayer(i,j))
       {
         kolomgeklikt = i;
         rijgeklikt = j;
       }
     }
   }
   else // tweede deel van zet
   {
     // if clicked on same square, clicking undone
     if (i == kolomgeklikt && j == rijgeklikt)
     { rijgeklikt = -1;
       kolomgeklikt = -1;
     }
     else if (controle.LegalMove(kolomgeklikt,rijgeklikt,i,j))
     {
       if (controle.RightPlayer(kolomgeklikt,rijgeklikt,i,j))
        { 
          controle.DoMove (kolomgeklikt,rijgeklikt,i,j);
          rijgeklikt = -1;
	  kolomgeklikt = -1;
	  repaint();
	  controle.MakeComputerMove();
        }
     }
   }
}
}

// drawpiece. Tekent op positie (i,j) het stuk uit variabele stuk.

public void drawpiece (Graphics g, int i, int j)
  {
   // tekent het schaakstuk op positie i,j
   Image tetekenen;

   if (bord[i][j] == 0)
   { drawsquare (g, i, j); }
   else if (bord[i][j] == 1000)
     { drawsquare (g, i, j); }
   else
   {
     if      ( bord [i][j] == 1 )  tetekenen = WhiteKing;
     else if ( bord [i][j] == 2 )  tetekenen = BlackKing;
     else if ( bord [i][j] == 3 )  tetekenen = WhiteQueen;
     else if ( bord [i][j] == 4 )  tetekenen = BlackQueen;
     else if ( bord [i][j] == 5 )  tetekenen = WhiteRook;
     else if ( bord [i][j] == 6 )  tetekenen = BlackRook;
     else if ( bord [i][j] == 7 )  tetekenen = WhiteKnight;
     else if ( bord [i][j] == 8 )  tetekenen = BlackKnight;
     else if ( bord [i][j] == 9 )  tetekenen = WhiteBishop;
     else if ( bord [i][j] == 10 ) tetekenen = BlackBishop;
     else if ( bord [i][j] == 11 ) tetekenen = WhitePawn;
     else if ( bord [i][j] == 12 ) tetekenen = BlackPawn;
     else if ( bord [i][j] == 13 ) tetekenen = WhiteChancellor;
     else if ( bord [i][j] == 14 ) tetekenen = BlackChancellor;
     else if ( bord [i][j] == 15 ) tetekenen = WhiteMarshal;
     else if ( bord [i][j] == 16 ) tetekenen = BlackMarshal;
     else if ( bord [i][j] == 31 ) tetekenen = WhiteBishop;
     else if ( bord [i][j] == 32 ) tetekenen = BlackBishop;
     else if ( bord [i][j] == 33 ) tetekenen = WhiteBishop;
     else if ( bord [i][j] == 34 ) tetekenen = BlackBishop;

     else tetekenen = WhiteKing ; // stupid default for errors
     g.drawImage (tetekenen, i*veldgrootte, (aantalrijen-j-1)*veldgrootte,
       veldgrootte, veldgrootte, this);
   }
  }

//---------------------------------------------------------------------------
// Methode voor het laden van de plaatjes

// LoadImages laadt de plaatjes. Later met parameters maken voor varianten.
// Deze laadt alleen de standaard stukken en is nog niet af.
public void LoadImages ()
  {
tracker = new MediaTracker(this);

WhitePawn = GetImageWithName("pawnw.gif");
tracker.addImage(WhitePawn, 0);
BlackPawn = GetImageWithName("pawnb.gif");
tracker.addImage(BlackPawn, 0);
WhiteKing = GetImageWithName("kingw.gif");
tracker.addImage(WhiteKing, 0);
BlackKing = GetImageWithName("kingb.gif");
tracker.addImage(BlackKing, 0);
WhiteQueen = GetImageWithName("queenw.gif");
tracker.addImage(WhiteQueen, 0);
BlackQueen = GetImageWithName("queenb.gif");
tracker.addImage(BlackQueen, 0);
WhiteBishop = GetImageWithName("bishopw.gif");
tracker.addImage(WhiteBishop, 0);
BlackBishop = GetImageWithName("bishopb.gif");
tracker.addImage(BlackBishop, 0);
WhiteKnight = GetImageWithName("knightw.gif");
tracker.addImage(WhiteKnight, 0);
BlackKnight = GetImageWithName("knightb.gif");
tracker.addImage(BlackKnight, 0);
WhiteRook = GetImageWithName("rookw.gif");
tracker.addImage(WhiteRook, 0);
BlackRook = GetImageWithName("rookb.gif");
tracker.addImage(BlackRook, 0);
// Special pieces are not loaded automatically!
WhiteChancellor = GetImageWithName("chancellorw.gif");
BlackChancellor = GetImageWithName("chancellorb.gif");
WhiteMarshal = GetImageWithName("marshalw.gif");
BlackMarshal = GetImageWithName("marshalb.gif");
try {
     //Start downloading the images. Wait until they're loaded.
     tracker.waitForAll();
    } catch (InterruptedException e) {};
}

Image GetImageWithName (String s)
{ Image im;
try
   {
     im = parent.getImage(new URL(parent.getDocumentBase(), s));
   }
  catch (MalformedURLException e){ im = null;}
  return im;
}

//--------------------------------------------------------------------


// ForsytheToBoard gets a string that gives a chessboard in Forsythe notation
// and puts in output the chessboard, using the conventions
// 0 = leeg veld
// 1 = witte koning;
// 2 = zwarte koning;
// 3 = witte dame;
// 4 = zwarte dame;
// 5 = witte toren;
// 6 = zwarte toren;
// 7 = wit paard;
// 8 = zwart paard;
// 9 = witte loper;
// 10 = zwarte loper;
// 11 = witte pion;
// 12 = zwarte pion;
// 13 = white chancellor; (R+N)
// 14 = black chancellor; (R+N)
// 15 = white marshal; (B+N)
// 16 = black marshal; (B+N)
// To be precise: letters denote pieces, small case white, upper case black
// empty squares are denoted with a number, and rows separated by one / symbol
// so starting setup is:
// 31, 32, 33, 34: L resp l: voor Bishops Conversion Rule. See above.

public void ForsytheToBoard (String input)
{
  for (int i=0; i<aantalkolommen; i++)
  { for (int j=0; j<aantalrijen; j++)
    { bord[i][j]=0;
    }
  }
   
  int parseplace = 0; // parseplace is position in input string where we read.

  int x = 0;
  int y = aantalrijen-1;
  while ( parseplace < input.length())
  { char inputparseplace = input.charAt(parseplace);
    if (inputparseplace == '/') {x=0; y--;}
    else if (inputparseplace == '-') {bord[x][y] = 1000; x++;}
    else if ('1' <= inputparseplace && inputparseplace <= '9')
	 { 
	    int toskip = inputparseplace - '0' ;
	    if (parseplace + 1 < input.length())
	    { char nextchar = input.charAt(parseplace + 1);
	      if ('0' <= nextchar && nextchar <= '9')
	      {
		parseplace ++ ; // skip one to the right; the next is done at the end
		toskip = 10 * toskip + nextchar - '0';
              }
            }
            x+= toskip;
          }
    else if (x < aantalkolommen && y  > -1)
	 { bord[x][y] = Char2Piece(inputparseplace); x++;
	 }
    parseplace++;
  }

// sets castling squares right
  controle. SetKingPosition();
}

// gives number code for piece letter from Forsythe notation
public static int Char2Piece (char letter)
{
  if (letter == 'K') return 1;
  if (letter == 'k') return 2;
  if (letter == 'Q') return 3;
  if (letter == 'q') return 4;
  if (letter == 'R') return 5;
  if (letter == 'r') return 6;
  if (letter == 'N') return 7;
  if (letter == 'n') return 8;
  if (letter == 'B') return 9;
  if (letter == 'b') return 10;
  if (letter == 'P') return 11;
  if (letter == 'p') return 12;
  if (letter == 'C') return 13;
  if (letter == 'c') return 14;
  if (letter == 'M') return 15;
  if (letter == 'm') return 16;
  if (letter == 'L') return 31;
  if (letter == 'l') return 32;
  if (letter == '-') return 1000;

  return 0;         // default: something went wrong so empty square
}

// ==========================================

// Lees een string die de kleuren geeft.
// blauwe worden met getal weergegeven
public void ColorBoard ()
{
  for (int i=0; i<aantalkolommen; i++)
  { for (int j=0; j<aantalrijen; j++)
    {
       if ((i+j) % 2 == 0)
          { kleurveld[i][j]= 'B'; }
       else
          { kleurveld[i][j]= 'b'; }
    }
  }
}

public void ColorBoard (String input)
{
  ColorBoard();
  int parseplace = 0; // parseplace is position in input string where we read.
  int x = 0;
  int y = aantalrijen-1;
  while (parseplace < input.length())
  { char inputparseplace = input.charAt(parseplace);
    if (inputparseplace >= 'A' && inputparseplace <= 'Z')
       {
	 if ( x < aantalkolommen && y > -1  )
	 {
	    kleurveld[x][y] = inputparseplace; x++;
	 }
       }
    else if (inputparseplace >= 'a' && inputparseplace <= 'z')
       {
	 if ( x < aantalkolommen && y > -1 )
	 {
	    kleurveld[x][y] = inputparseplace; x++;
	 }
       }
    else if ('1' <= inputparseplace && inputparseplace <= '9')
	 { 
	    int toskip = inputparseplace - '0' ;
	    if (parseplace + 1 < input.length())
	    { char nextchar = input.charAt(parseplace + 1);
	      if ('0' <= nextchar && nextchar <= '9')
	      {
		parseplace ++;
		toskip = 10 * toskip + nextchar - '0';
              }
            }
            x+= toskip;
         }
    else if (inputparseplace == '/')
	 { 
	   x=0;
	   y--;
         }
    parseplace++;
  }
}

//

public void DisableCastling()
{
  controle.DisableCastling();
}

public void DisableDoublePawnStep()
{
  controle.DisableDoublePawnStep();
}

public void DisableDoublePawnStep(int player)
{
  controle.DisableDoublePawnStep(player);
}

// END OF CLASS
}
